/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package presentation;

import entities.Agence;
import entities.Client;
import entities.Compte;
import entities.Operation;
import java.awt.Component;
import java.util.ArrayList;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import service.ClientService;

/**
 *
 * @author babacarbasse
 */
public class Home extends javax.swing.JFrame {

    /**
     * Creates new form Home
     */
    public Home() {
        initComponents();
        this.clientService = new ClientService();
        initFromServer();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        nomAgenceTextField = new javax.swing.JTextField();
        adresseAgenceTextField = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        tableListeAgence = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        prenomClientTextField = new javax.swing.JTextField();
        nomClientTextField = new javax.swing.JTextField();
        jScrollPane2 = new javax.swing.JScrollPane();
        nomAgClientList = new javax.swing.JList<>();
        jButton2 = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        listeAgenceComboBox = new javax.swing.JComboBox<>();
        jLabel9 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        listClientAgenceTable = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        libelleCptClient = new javax.swing.JTextField();
        jButtonAddCompte = new javax.swing.JButton();
        jComboBoxNumClient = new javax.swing.JComboBox<>();
        jLabel14 = new javax.swing.JLabel();
        jComboBoxAgenceCpt = new javax.swing.JComboBox<>();
        jLabelAfficheNomClient = new javax.swing.JLabel();
        jLabelAffichePrenomClient = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTableListCompteClient = new javax.swing.JTable();
        jPanel4 = new javax.swing.JPanel();
        jPanel9 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        montantOperation = new javax.swing.JTextField();
        jButtonAddCompte1 = new javax.swing.JButton();
        jComboBoxNumClientOp = new javax.swing.JComboBox<>();
        jLabel17 = new javax.swing.JLabel();
        jComboBoxAgenceOp = new javax.swing.JComboBox<>();
        jLabelAfficheNomClientOp = new javax.swing.JLabel();
        jLabelAffichePrenomClientOp = new javax.swing.JLabel();
        jRadioButtonCredit = new javax.swing.JRadioButton();
        jRadioButtonDebit = new javax.swing.JRadioButton();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        libelleOp = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        jComboBoxListCompteClient = new javax.swing.JComboBox<>();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTableListOpCli = new javax.swing.JTable();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel5.setBackground(new java.awt.Color(246, 108, 49));

        jLabel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setFont(new java.awt.Font("Abyssinica SIL", 1, 12)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(51, 51, 51));
        jLabel1.setText("Nouvelle Agence");

        jLabel2.setText("Nom :");

        jLabel3.setText("Adresse :");

        nomAgenceTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nomAgenceTextFieldActionPerformed(evt);
            }
        });

        jButton1.setBackground(new java.awt.Color(64, 157, 69));
        jButton1.setText("Ajouter");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(30, 30, 30)
                                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(26, 26, 26)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(adresseAgenceTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 424, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addComponent(nomAgenceTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 424, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 167, Short.MAX_VALUE)
                                .addComponent(jLabel1)))))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(nomAgenceTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2)))
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(adresseAgenceTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jScrollPane1.setBackground(new java.awt.Color(230, 145, 27));

        tableListeAgence.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Numéro", "Nom", "Adresse"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(tableListeAgence);
        if (tableListeAgence.getColumnModel().getColumnCount() > 0) {
            tableListeAgence.getColumnModel().getColumn(0).setResizable(false);
            tableListeAgence.getColumnModel().getColumn(0).setPreferredWidth(10);
            tableListeAgence.getColumnModel().getColumn(1).setResizable(false);
            tableListeAgence.getColumnModel().getColumn(1).setPreferredWidth(40);
            tableListeAgence.getColumnModel().getColumn(2).setResizable(false);
            tableListeAgence.getColumnModel().getColumn(2).setPreferredWidth(50);
        }

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane1)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 594, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jTabbedPane1.addTab("Gestion Agence", jPanel1);

        jPanel6.setBackground(new java.awt.Color(246, 108, 49));

        jLabel4.setText("Prénom :");

        jLabel5.setText("Nom :");

        jLabel6.setText("Agence :");

        jLabel7.setBackground(new java.awt.Color(255, 255, 255));
        jLabel7.setFont(new java.awt.Font("Abyssinica SIL", 1, 12)); // NOI18N
        jLabel7.setForeground(new java.awt.Color(51, 51, 51));
        jLabel7.setText("Nouveau Client");

        nomAgClientList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane2.setViewportView(nomAgClientList);

        jButton2.setBackground(new java.awt.Color(64, 157, 69));
        jButton2.setText("Ajouter Client");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.TRAILING))
                .addGap(41, 41, 41)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(prenomClientTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 449, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 135, Short.MAX_VALUE)
                        .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(nomClientTextField)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 449, Short.MAX_VALUE))
                        .addGap(64, 64, 64)
                        .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(prenomClientTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel5)
                            .addComponent(nomClientTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addComponent(jLabel6)
                                .addGap(0, 70, Short.MAX_VALUE))
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jButton2)))
                .addContainerGap())
        );

        listeAgenceComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        listeAgenceComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                listeAgenceComboBoxItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(listeAgenceComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 328, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(listeAgenceComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        jLabel9.setBackground(new java.awt.Color(255, 255, 255));
        jLabel9.setFont(new java.awt.Font("Chandas", 1, 12)); // NOI18N
        jLabel9.setForeground(new java.awt.Color(51, 51, 51));
        jLabel9.setText("Selectionnez une agence");

        jLabel8.setBackground(new java.awt.Color(255, 255, 255));
        jLabel8.setFont(new java.awt.Font("Abyssinica SIL", 1, 12)); // NOI18N
        jLabel8.setForeground(new java.awt.Color(51, 51, 51));
        jLabel8.setText("Liste Client");

        listClientAgenceTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null}
            },
            new String [] {
                "Numéro", "Prénom", "Nom"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane3.setViewportView(listClientAgenceTable);
        if (listClientAgenceTable.getColumnModel().getColumnCount() > 0) {
            listClientAgenceTable.getColumnModel().getColumn(0).setResizable(false);
            listClientAgenceTable.getColumnModel().getColumn(0).setPreferredWidth(10);
            listClientAgenceTable.getColumnModel().getColumn(1).setResizable(false);
            listClientAgenceTable.getColumnModel().getColumn(1).setPreferredWidth(50);
            listClientAgenceTable.getColumnModel().getColumn(2).setResizable(false);
            listClientAgenceTable.getColumnModel().getColumn(2).setPreferredWidth(40);
        }

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane3)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel9)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 77, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Gestion Client", jPanel2);

        jPanel8.setBackground(new java.awt.Color(246, 108, 49));

        jLabel10.setText("Libellé:");

        jLabel12.setText("Client:");

        jLabel13.setBackground(new java.awt.Color(255, 255, 255));
        jLabel13.setFont(new java.awt.Font("Abyssinica SIL", 1, 12)); // NOI18N
        jLabel13.setForeground(new java.awt.Color(51, 51, 51));
        jLabel13.setText("Nouveau Compte");

        jButtonAddCompte.setBackground(new java.awt.Color(64, 157, 69));
        jButtonAddCompte.setText("Ajouter Compte");
        jButtonAddCompte.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddCompteActionPerformed(evt);
            }
        });

        jComboBoxNumClient.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBoxNumClientItemStateChanged(evt);
            }
        });

        jLabel14.setText("Agence:");

        jComboBoxAgenceCpt.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxAgenceCpt.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBoxAgenceCptItemStateChanged(evt);
            }
        });

        jLabelAfficheNomClient.setFont(new java.awt.Font("DialogInput", 1, 12)); // NOI18N

        jLabelAffichePrenomClient.setFont(new java.awt.Font("DialogInput", 1, 12)); // NOI18N

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 75, Short.MAX_VALUE)
                        .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jLabelAffichePrenomClient, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(libelleCptClient)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel8Layout.createSequentialGroup()
                                .addComponent(jComboBoxAgenceCpt, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jComboBoxNumClient, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(14, 14, 14))
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(jLabelAfficheNomClient, javax.swing.GroupLayout.PREFERRED_SIZE, 274, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(92, 92, 92)
                        .addComponent(jButtonAddCompte, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel10)
                            .addComponent(libelleCptClient, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBoxNumClient, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel12)
                    .addComponent(jLabel14)
                    .addComponent(jComboBoxAgenceCpt, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 39, Short.MAX_VALUE)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabelAffichePrenomClient, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabelAfficheNomClient, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jButtonAddCompte))
                .addContainerGap())
        );

        jTableListCompteClient.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Numéro", "Libellé", "Sens", "Solde"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane4.setViewportView(jTableListCompteClient);
        if (jTableListCompteClient.getColumnModel().getColumnCount() > 0) {
            jTableListCompteClient.getColumnModel().getColumn(0).setResizable(false);
            jTableListCompteClient.getColumnModel().getColumn(0).setPreferredWidth(10);
            jTableListCompteClient.getColumnModel().getColumn(1).setResizable(false);
            jTableListCompteClient.getColumnModel().getColumn(1).setPreferredWidth(40);
            jTableListCompteClient.getColumnModel().getColumn(2).setResizable(false);
            jTableListCompteClient.getColumnModel().getColumn(2).setPreferredWidth(10);
            jTableListCompteClient.getColumnModel().getColumn(3).setResizable(false);
            jTableListCompteClient.getColumnModel().getColumn(3).setPreferredWidth(20);
        }

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane4)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 565, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Gestion Compte", jPanel3);

        jPanel9.setBackground(new java.awt.Color(246, 108, 49));

        jLabel11.setText("Montant :");

        jLabel15.setText("Client:");

        jLabel16.setBackground(new java.awt.Color(255, 255, 255));
        jLabel16.setFont(new java.awt.Font("Abyssinica SIL", 1, 12)); // NOI18N
        jLabel16.setForeground(new java.awt.Color(51, 51, 51));
        jLabel16.setText("Nouvelle Opération");

        jButtonAddCompte1.setBackground(new java.awt.Color(64, 157, 69));
        jButtonAddCompte1.setText("Ajouter Opération");
        jButtonAddCompte1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddCompte1ActionPerformed(evt);
            }
        });

        jComboBoxNumClientOp.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBoxNumClientOpItemStateChanged(evt);
            }
        });

        jLabel17.setText("Agence :");

        jComboBoxAgenceOp.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxAgenceOp.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBoxAgenceOpItemStateChanged(evt);
            }
        });
        jComboBoxAgenceOp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxAgenceOpActionPerformed(evt);
            }
        });

        jLabelAfficheNomClientOp.setFont(new java.awt.Font("DialogInput", 1, 12)); // NOI18N
        jLabelAfficheNomClientOp.setText("Basse");

        jLabelAffichePrenomClientOp.setFont(new java.awt.Font("DialogInput", 1, 12)); // NOI18N
        jLabelAffichePrenomClientOp.setText("Babacat");

        buttonGroup1.add(jRadioButtonCredit);
        jRadioButtonCredit.setText("Crédit");
        jRadioButtonCredit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonCreditActionPerformed(evt);
            }
        });

        buttonGroup1.add(jRadioButtonDebit);
        jRadioButtonDebit.setText("Débit");

        jLabel18.setText("Sens Opération :");

        jLabel19.setText("Libellé :");

        jLabel20.setText("Compte :");

        jComboBoxListCompteClient.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxListCompteClient.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jComboBoxListCompteClientItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                        .addComponent(jLabel19, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 146, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(16, 16, 16))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addComponent(jLabelAffichePrenomClientOp, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabelAfficheNomClientOp, javax.swing.GroupLayout.PREFERRED_SIZE, 274, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButtonAddCompte1, javax.swing.GroupLayout.PREFERRED_SIZE, 186, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(jLabel20, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(29, 29, 29)
                                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel9Layout.createSequentialGroup()
                                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jComboBoxAgenceOp, javax.swing.GroupLayout.PREFERRED_SIZE, 389, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                .addComponent(libelleOp, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 295, Short.MAX_VALUE)
                                                .addComponent(montantOperation, javax.swing.GroupLayout.Alignment.LEADING)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE)
                                        .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jComboBoxNumClientOp, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanel9Layout.createSequentialGroup()
                                        .addComponent(jComboBoxListCompteClient, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jRadioButtonCredit)
                                        .addGap(18, 18, 18)
                                        .addComponent(jRadioButtonDebit)
                                        .addGap(27, 27, 27)))))
                        .addContainerGap())))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel19))
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(libelleOp, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel11)
                    .addComponent(montantOperation, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jComboBoxNumClientOp, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel15)
                        .addComponent(jLabel17))
                    .addComponent(jComboBoxAgenceOp, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel18)
                    .addComponent(jRadioButtonDebit)
                    .addComponent(jRadioButtonCredit, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel20)
                    .addComponent(jComboBoxListCompteClient, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelAffichePrenomClientOp, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelAfficheNomClientOp, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonAddCompte1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTableListOpCli.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Numéro", "Libellé", "Sens", "Montant", "Date"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.Double.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane5.setViewportView(jTableListOpCli);
        if (jTableListOpCli.getColumnModel().getColumnCount() > 0) {
            jTableListOpCli.getColumnModel().getColumn(0).setResizable(false);
            jTableListOpCli.getColumnModel().getColumn(0).setPreferredWidth(10);
            jTableListOpCli.getColumnModel().getColumn(1).setResizable(false);
            jTableListOpCli.getColumnModel().getColumn(1).setPreferredWidth(40);
            jTableListOpCli.getColumnModel().getColumn(2).setResizable(false);
            jTableListOpCli.getColumnModel().getColumn(2).setPreferredWidth(10);
            jTableListOpCli.getColumnModel().getColumn(3).setResizable(false);
            jTableListOpCli.getColumnModel().getColumn(3).setPreferredWidth(20);
            jTableListOpCli.getColumnModel().getColumn(4).setResizable(false);
            jTableListOpCli.getColumnModel().getColumn(4).setPreferredWidth(20);
        }

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane5))
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 484, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jTabbedPane1.addTab("Opération", jPanel4);

        jMenu2.setText("Settings");
        jMenu2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jMenu2.setVerifyInputWhenFocusTarget(false);
        jMenu2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenu2ActionPerformed(evt);
            }
        });

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText("Quitter");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBoxListCompteClientItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBoxListCompteClientItemStateChanged
        // TODO add your handling code here:
        this.initListOperationClient();
    }//GEN-LAST:event_jComboBoxListCompteClientItemStateChanged

    private void jRadioButtonCreditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonCreditActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jRadioButtonCreditActionPerformed

    private void jComboBoxAgenceOpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxAgenceOpActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxAgenceOpActionPerformed

    private void jComboBoxAgenceOpItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBoxAgenceOpItemStateChanged
        // TODO add your handling code here:
        this.initListClientAgenceOp();
        this.initListCompteClientOp();
        this.initListOperationClient();
    }//GEN-LAST:event_jComboBoxAgenceOpItemStateChanged

    private void jComboBoxNumClientOpItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBoxNumClientOpItemStateChanged
        // TODO add your handling code here:
        this.initListOperationClient();
        this.initListCompteClientOp();
        int numSelectedCli = (Integer)jComboBoxNumClientOp.getSelectedItem();
        for (Client cli: this.listeClientAgenceOp) {
            if (cli.getNumCli() == numSelectedCli) {
                this.jLabelAffichePrenomClientOp.setText(cli.getPrenom());
                this.jLabelAfficheNomClientOp.setText(cli.getNom());
                return;
            }
        }
    }//GEN-LAST:event_jComboBoxNumClientOpItemStateChanged

    private void jButtonAddCompte1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddCompte1ActionPerformed
        // TODO add your handling code here:
        if (this.montantOperation.getText().equals("") || this.jComboBoxListCompteClient.getItemCount() == 0 ||
            this.libelleOp.getText().equals("")) {
            return;
        }
        String sensOp = "";
        if (this.jRadioButtonCredit.isSelected()) {
            sensOp = "CR";
        } else {
            if (this.jRadioButtonDebit.isSelected()) {
                sensOp = "DB";
            } else { return; }
        }
        Double montant = Double.valueOf(this.montantOperation.getText());
        String libOp = this.libelleOp.getText();
        String compte = (String)this.jComboBoxListCompteClient.getSelectedItem();
        Operation operation = new Operation(libOp, sensOp, montant, compte);
        System.err.println(libOp + " "+ sensOp+" "+montant+ " "+ compte);
        this.clientService.addOperationCompte(operation);
        this.reinitAddOperation();
    }//GEN-LAST:event_jButtonAddCompte1ActionPerformed

    private void jComboBoxAgenceCptItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBoxAgenceCptItemStateChanged
        // TODO add your handling code here:
        this.initListClientAgenceCpt();
        this.initListCompteClient();
    }//GEN-LAST:event_jComboBoxAgenceCptItemStateChanged

    private void jComboBoxNumClientItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBoxNumClientItemStateChanged
        // TODO add your handling code here:
        this.initListCompteClient();
        int numSelectedCli = (Integer)jComboBoxNumClient.getSelectedItem();
        for (Client cli: this.listeClientAgenceCpt) {
            if (cli.getNumCli() == numSelectedCli) {
                this.jLabelAffichePrenomClient.setText(cli.getPrenom());
                this.jLabelAfficheNomClient.setText(cli.getNom());
                return;
            }
        }
    }//GEN-LAST:event_jComboBoxNumClientItemStateChanged

    private void jButtonAddCompteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddCompteActionPerformed
        // TODO add your handling code here:
        if (this.jComboBoxNumClient.getItemCount() == 0 || this.libelleCptClient.getText().equals("")) {
            return;
        }
        Compte compte = new Compte(this.libelleCptClient.getText(), (Integer)this.jComboBoxNumClient.getSelectedItem());
        this.clientService.addCompte(compte);
        this.reinitAddCompte();
    }//GEN-LAST:event_jButtonAddCompteActionPerformed

    private void listeAgenceComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listeAgenceComboBoxItemStateChanged
        // Change liste Client Agence
        this.initListClientAgence();
    }//GEN-LAST:event_listeAgenceComboBoxItemStateChanged

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // AjoutClient
        String nom = this.nomClientTextField.getText();
        String prenom = this.prenomClientTextField.getText();
        String agence = this.nomAgClientList.getSelectedValue();
        if (nom.equals("") || prenom.equals("") || agence.equals("")) {
            return;
        }
        int numAgence = this.clientService.getNumAgenceByNom(agence);
        if (numAgence != -1) {
            Client client = new Client(nom, prenom, numAgence);
            this.clientService.addClient(client);
            this.reinitAddClient();
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Ajout Agence
        String nom = this.nomAgenceTextField.getText();
        String adresse = this.adresseAgenceTextField.getText();
        if (nom.equals("") || adresse.equals("")) {
            return;
        }
        Agence agence;
        agence = new Agence(nom, adresse);
        this.clientService.addAgence(agence);
        this.reinitAddAgence();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void nomAgenceTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nomAgenceTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_nomAgenceTextFieldActionPerformed

    private void jMenu2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenu2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenu2ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // TODO add your handling code here:
        int exit = JOptionPane.showConfirmDialog(null, "Voulez-vous vraiment quitter l'application?");
        if (exit == 0) {
           System.exit(0);
        }
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Home.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Home.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Home.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Home.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Home().setVisible(true);
            }
        });
    }
    
    private void reinitAddAgence() {
        this.nomAgenceTextField.setText("");
        this.adresseAgenceTextField.setText("");
        this.initFromServer();
    }
    
    private void reinitAddClient() {
        this.nomClientTextField.setText("");
        this.prenomClientTextField.setText("");
        this.initListClientAgence();
        this.initListClientAgenceCpt();
    }
    
    private void reinitAddCompte() {
        this.libelleCptClient.setText("");
        this.initListCompteClient();
    }
    
    private void reinitAddOperation() {
        this.libelleOp.setText("");
        this.montantOperation.setText("");
        this.initListCompteClient();
        this.initListOperationClient();
    }

    private void initFromServer() {
        this.listeAgence = this.clientService.getListeAgence();
        DefaultTableModel model = (DefaultTableModel) tableListeAgence.getModel();
        model.setRowCount(0);
        DefaultListModel<String> listModel = new DefaultListModel<>();
        DefaultComboBoxModel<String> listComboModel = new DefaultComboBoxModel<>();
        this.listeAgenceComboBox.setModel(listComboModel);
        this.nomAgClientList.setModel(listModel);
        
        DefaultComboBoxModel<String> listComboModelAgCpt = new DefaultComboBoxModel<>();
        this.jComboBoxAgenceCpt.setModel(listComboModelAgCpt);
        
        DefaultComboBoxModel<String> listComboModelAgOp = new DefaultComboBoxModel<>();
        this.jComboBoxAgenceOp.setModel(listComboModelAgOp);
        int ligne = 0;
        for (Agence agence: this.listeAgence) {
            model.addRow(new Object[0]);
            model.setValueAt(agence.getNumAg(), ligne, 0);
            model.setValueAt(agence.getNomAg(), ligne, 1);
            model.setValueAt(agence.getAdresseAg(), ligne, 2);
            listModel.addElement(agence.getNomAg());
            listComboModel.addElement(agence.getNomAg());
            listComboModelAgCpt.addElement(agence.getNomAg());
            listComboModelAgOp.addElement(agence.getNomAg());
            ligne++;
        }
        this.initListClientAgence();
        this.initListClientAgenceCpt();
        this.initListClientAgenceOp();
    }
    
    public void initListClientAgence() {
        String nomAgence = (String) this.listeAgenceComboBox.getSelectedItem();
        this.listeClientAgence = this.clientService.getListeClientAgence(nomAgence);
        DefaultTableModel model = (DefaultTableModel) listClientAgenceTable.getModel();
        model.setRowCount(0);
        int ligne = 0;
        for (Client client: this.listeClientAgence) {
            model.addRow(new Object[0]);
            model.setValueAt(client.getNumCli(), ligne, 0);
            model.setValueAt(client.getPrenom(), ligne, 1);
            model.setValueAt(client.getNom(), ligne, 2);
            ligne++;
        }
    }
    
    public void initListClientAgenceCpt() {
        String nomAgence = (String) this.jComboBoxAgenceCpt.getSelectedItem();
        this.listeClientAgenceCpt = this.clientService.getListeClientAgence(nomAgence);
        DefaultComboBoxModel<Integer> listComboModelNumCliCpt = new DefaultComboBoxModel<>();
        this.jComboBoxNumClient.setModel(listComboModelNumCliCpt);
        if (this.listeClientAgenceCpt.isEmpty()) {
            this.jLabelAffichePrenomClient.setText("");
            this.jLabelAfficheNomClient.setText("");
            return;
        }
        for (Client client: this.listeClientAgenceCpt) {
            listComboModelNumCliCpt.addElement(client.getNumCli());
        }
    }
    
    public void initListClientAgenceOp() {
        String nomAgence = (String) this.jComboBoxAgenceOp.getSelectedItem();
        this.listeClientAgenceOp = this.clientService.getListeClientAgence(nomAgence);
        DefaultComboBoxModel<Integer> listComboModelNumCliOp = new DefaultComboBoxModel<>();
        this.jComboBoxNumClientOp.setModel(listComboModelNumCliOp);
        if (this.listeClientAgenceOp.isEmpty()) {
            this.jLabelAffichePrenomClientOp.setText("");
            this.jLabelAfficheNomClientOp.setText("");
            return;
        }
        for (Client client: this.listeClientAgenceOp) {
            listComboModelNumCliOp.addElement(client.getNumCli());
        }
    }
    
    public void initListCompteClient() {
        DefaultTableModel model = (DefaultTableModel) jTableListCompteClient.getModel();
        model.setRowCount(0);
        if (this.listeClientAgenceCpt.isEmpty()) {
            return;
        }
        int numCli = (Integer)this.jComboBoxNumClient.getSelectedItem();
        this.listeCompteClient = this.clientService.getListeCompteClient(numCli);
        int ligne = 0;
        for (Compte compte: this.listeCompteClient) {
            model.addRow(new Object[0]);
            model.setValueAt(compte.getNumCpt(), ligne, 0);
            model.setValueAt(compte.getLibelleCpt(), ligne, 1);
            if (compte.getSens().equals("CR")) {
                model.setValueAt("Créditaire", ligne, 2);
            } else {
                model.setValueAt("Débitaire", ligne, 2);
            }
            model.setValueAt(compte.getSolde(), ligne, 3);
            ligne++;
            ColorRenderer cr=new ColorRenderer("Sens");
            jTableListCompteClient.getColumn(jTableListCompteClient.getColumnName(2)).setCellRenderer(cr);
        }
    }

    public void initListCompteClientOp() {
        DefaultComboBoxModel<String> listComboModelCptCliOp = new DefaultComboBoxModel<>();
        this.jComboBoxListCompteClient.setModel(listComboModelCptCliOp);
        if (this.listeClientAgenceOp.isEmpty()) {
            return;
        }
        int numCli = (Integer)this.jComboBoxNumClientOp.getSelectedItem();
        this.listeCompteClientOp = this.clientService.getListeCompteClient(numCli);
        for (Compte compte: this.listeCompteClientOp) {
            listComboModelCptCliOp.addElement(compte.getNumCpt());
        }
    }
    
    public void initListOperationClient() {
        DefaultTableModel model = (DefaultTableModel) jTableListOpCli.getModel();
        model.setRowCount(0);
        if (this.listeClientAgenceOp.isEmpty()) {
            return;
        }
        String numCompte = (String)this.jComboBoxListCompteClient.getSelectedItem();
        this.listeOperationCptClient = this.clientService.getListeOperationCptClient(numCompte);
        int ligne = 0;
        for (Operation operation: this.listeOperationCptClient) {
            model.addRow(new Object[0]);
            model.setValueAt(operation.getNumOp(), ligne, 0);
            model.setValueAt(operation.getLibOp(), ligne, 1);
            if (operation.getSensOp().equals("CR")) {
                model.setValueAt("Crédit", ligne, 2);
                
            } else {
                model.setValueAt("Débit", ligne, 2);
            }
            model.setValueAt(operation.getMontOp(), ligne, 3);
            model.setValueAt(operation.getDateOp() + " à " + operation.getTimeOp(), ligne, 4);
            ligne++;
            ColorRenderer cr=new ColorRenderer("Sens");
            jTableListOpCli.getColumn(jTableListOpCli.getColumnName(2)).setCellRenderer(cr);
        } 
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField adresseAgenceTextField;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButtonAddCompte;
    private javax.swing.JButton jButtonAddCompte1;
    private javax.swing.JComboBox<String> jComboBoxAgenceCpt;
    private javax.swing.JComboBox<String> jComboBoxAgenceOp;
    private javax.swing.JComboBox<String> jComboBoxListCompteClient;
    private javax.swing.JComboBox<Integer> jComboBoxNumClient;
    private javax.swing.JComboBox<Integer> jComboBoxNumClientOp;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelAfficheNomClient;
    private javax.swing.JLabel jLabelAfficheNomClientOp;
    private javax.swing.JLabel jLabelAffichePrenomClient;
    private javax.swing.JLabel jLabelAffichePrenomClientOp;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButtonCredit;
    private javax.swing.JRadioButton jRadioButtonDebit;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTableListCompteClient;
    private javax.swing.JTable jTableListOpCli;
    private javax.swing.JTextField libelleCptClient;
    private javax.swing.JTextField libelleOp;
    private javax.swing.JTable listClientAgenceTable;
    private javax.swing.JComboBox<String> listeAgenceComboBox;
    private javax.swing.JTextField montantOperation;
    private javax.swing.JList<String> nomAgClientList;
    private javax.swing.JTextField nomAgenceTextField;
    private javax.swing.JTextField nomClientTextField;
    private javax.swing.JTextField prenomClientTextField;
    private javax.swing.JTable tableListeAgence;
    // End of variables declaration//GEN-END:variables
    private final ClientService clientService;
    private ArrayList<Agence> listeAgence;
    private ArrayList<Client> listeClientAgence;
    private ArrayList<Client> listeClientAgenceCpt;
    private ArrayList<Compte> listeCompteClient;
    private ArrayList<Client> listeClientAgenceOp;
    private ArrayList<Compte> listeCompteClientOp;
    private ArrayList<Operation> listeOperationCptClient;
}

class ColorRenderer extends JLabel implements TableCellRenderer
    {
     private final String columnName;
     public ColorRenderer(String column)
         {
         this.columnName = column;
         setOpaque(true);
     }
     
     @Override
     public Component getTableCellRendererComponent(JTable table, Object value,boolean isSelected, boolean hasFocus, int row, int column)
         {
         Object columnValue=table.getValueAt(row,table.getColumnModel().getColumnIndex(columnName));
        
         if (value != null) setText(value.toString());
         if(isSelected)
             {
             setBackground(table.getSelectionBackground());
             setForeground(table.getSelectionForeground());
         }
         else
             {
             setBackground(table.getBackground());
             setForeground(table.getForeground());
             if (columnValue.equals("Créditaire") || columnValue.equals("Crédit")) setBackground(java.awt.Color.green);
             if (columnValue.equals("Débitaire") || columnValue.equals("Débit")) setBackground(java.awt.Color.red);
            
         }
         return this;
     }
    
}
